#ifndef __BA_EVENT_H__
#define __BA_EVENT_H__

#include <ba_config.h>

typedef enum {
    BA_EVENT_KIND_RESOURCE_IDLE = 0,
    BA_EVENT_KIND_RESOURCE_BUSY,
    BA_EVENT_KIND_USER_REQUEST_TASK,
    BA_EVENT_KIND_USER_ACTIVATE_NEW_TASK_SET,
    BA_EVENT_KIND_USERS_ADD_USER,
    BA_EVENT_KIND_USERS_REMOVE_USER,
    BA_EVENT_KIND_USERS_VC_TERMINATE,
    BA_EVENT_KIND_UNKNOWN,
} ba_event_kind_t;

typedef struct ba_event_s ba_event_t;

typedef void (ba_event_callback_t)(ba_event_kind_t kind,
				   ba_real delay_delta_time,
				   void *closure);

extern ba_event_kind_t ba_event_kind_get(ba_event_t *event);
extern ba_real ba_event_entered_abs_time_get(ba_event_t *event);
extern void *ba_event_callback_get(ba_event_t *event);
extern void *ba_event_closure_get(ba_event_t *event);
extern ba_id_t ba_event_id_get(ba_event_t *event);

extern void ba_event_invoke_callback(ba_event_t *event);
extern ba_real ba_event_action_abs_time_get(ba_event_t *event);
extern void ba_event_print(ba_event_t *event);
extern void ba_event_print_from_list(void *event_in,
				     void *unused);

extern ba_event_t *ba_event_new(ba_id_t id,
				ba_event_kind_t kind,
				ba_real entered_abs_time,
				ba_real action_abs_time,
				ba_event_callback_t callback,
				void *closure);
extern void ba_event_delete(ba_event_t *event);
extern void ba_event_delete_from_list(void *event_in,
				      void *unused);

#endif /* !__BA_EVENT_H__ */
