package ba_mysql_shared;
use strict;
use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $VERSION);

use Exporter;
$VERSION = 1.00;
@ISA = qw(Exporter);

@EXPORT = qw( $dbh $db_default_loc $db_dpetrou_pw $db_root_pw
	      
	      &db_ba_connect &db_connect &db_disconnect &db_new_db
              &db_renew_db &db_lock_tables &db_unlock_tables

	      &db_insert_trace &db_update_trace &db_delete_trace
	      &db_select_trace_id &db_select_trace_where_project_count
	      &db_select_trace_where &db_select_trace_where_ids
	      &db_find_trace_id

	      &db_insert_output &db_update_output
	      &db_select_output_id &db_select_output_where_project_count
	      &db_select_output_where &db_select_output_where_ids
	      &db_select_output_where_trace_input_ids
	      &db_select_output_where_project_trace_input_id
	      &db_get_trace_id_with_constraints &db_find_output_id

	      &db_insert_analyze &db_select_analyze_id
	      &db_select_analyze_where_project_count
	      &db_select_analyze_where &db_select_analyze_where_ids
	      &db_select_analyze_for_compare_ba &db_find_analyze_id );
@EXPORT_OK = qw( );
%EXPORT_TAGS = ( );

use vars qw( $dbh $db_default_loc $db_dpetrou_pw $db_root_pw );

######################################################################

use constant false => 0;
use constant true => 1;

use DBI;
use ba_harness_shared;

# general

$db_default_loc = "127.0.0.1";
#$db_default_loc = "partita.dsl.telerama.com";
$db_root_pw = "0tSbWq";
$db_dpetrou_pw = "oBmAyo";

use vars qw ( $real_fmt $dist_real_fmt $real_high_fmt );

## (the first num is the digits to the left of the dec + to the right
## of the dec.  the second is the digits to the right.)
#my $real_fmt = "DECIMAL(15,3)"; # +-99 billion
#my $real_high_fmt = "DECIMAL(20,6)"; # +-99 billion
#my $dist_real_fmt = "DECIMAL(14,6)"; # +-99 million

#my $real_fmt = "DOUBLE";
#my $real_high_fmt = "DOUBLE";
#my $dist_real_fmt = "DOUBLE";

my $real_fmt = "DECIMAL(20,6)";
my $real_high_fmt = "DECIMAL(20,6)";
my $dist_real_fmt = "DECIMAL(20,6)";

use vars qw ( $complete_trace_cols_types $complete_output_cols_types
	      $complete_analyze_cols_types

	      $complete_trace_cols $complete_output_cols $complete_analyze_cols

	      $made_cols_vars );

$made_cols_vars = false;

use vars qw( $program_len $version_len $hostname_len $sched_len
	     $dist_kind_len $ana_metric_order_len );

$program_len = 10;
$version_len = 10;
$hostname_len = 80;
$sched_len = 10;
$dist_kind_len = 20;
$ana_metric_order_len = 5;

# shared columns among trace and output

use vars qw( $id_col $program_col $version_col $hostname_col $args_col
	     $run_date_col $random_seed_col $trace_input_col
	     $trace_output_col );

$id_col = "id INT UNSIGNED AUTO_INCREMENT NOT NULL";
$program_col = "program VARCHAR($program_len) BINARY NOT NULL";
$version_col = "version VARCHAR($version_len) BINARY NOT NULL";
$hostname_col = "hostname VARCHAR($hostname_len) BINARY NOT NULL";
$args_col = "args BLOB NOT NULL";
$run_date_col = "run_date DATETIME NOT NULL";
$random_seed_col = "random_seed INT UNSIGNED NOT NULL";

$trace_input_col = "trace_input BLOB NULL";
$trace_output_col = "trace_output BLOB NULL";

# trace columns

use vars qw ( $num_users_col $virtual_clock_terminate_col
	      $max_req_dis_tasks_per_user_col
	      $user_arrivals_col
	      $task_set_change_range_col $tasks_per_task_set_col
	      $service_time_col $think_time_col );

$num_users_col = "num_users INT UNSIGNED NOT NULL";
$virtual_clock_terminate_col = "virtual_clock_terminate $real_fmt NOT NULL";
$max_req_dis_tasks_per_user_col =
    "max_req_dis_tasks_per_user INT UNSIGNED NOT NULL";
$user_arrivals_col = "user_arrivals";
$task_set_change_range_col = "task_set_change_range";
$tasks_per_task_set_col = "tasks_per_task_set";
$service_time_col = "service_time";
$think_time_col = "think_time";

# output columns

use vars qw ( $treat_req_dis_diff_col $req_sched_col $dis_sched_col
	      $trace_input_id_col $virtual_clock_col $all_cand_queue_col
	      $all_cand_queue_weighed_col $req_cand_queue_col
	      $req_cand_queue_weighed_col $dis_cand_queue_col
	      $dis_cand_queue_weighed_col $all_res_usage_col $req_res_usage_col
	      $dis_res_usage_col $billable_resources_col $scaled_res_usage_col
	      $res_busy_range_time_col $res_busy_time_col $res_idle_time_col
	      $non_work_cons_time_col $load_col $req_load_col
	      $req_load_ignoring_idle_col $user_count_col
	      $num_hit_req_dis_limit_col $task_sets_col
	      $task_sets_alive_time_col $no_task_sets_alive_time_col
	      $tasks_ready_time_col $disclosed_tasks_col
	      $disclosed_only_tasks_col $executed_tasks_col
	      $requested_tasks_col $finished_tasks_col $canceled_tasks_col
	      $vrt_col $vsd_col $user_vrt_col $user_vsd_col
	      $deadlines_met_col );

$treat_req_dis_diff_col = "treat_req_dis_diff BOOL NOT NULL";
$req_sched_col = "req_sched VARCHAR($sched_len) BINARY NOT NULL";
$dis_sched_col = "dis_sched VARCHAR($sched_len) BINARY NOT NULL";
$trace_input_id_col =
    "trace_input_id INT UNSIGNED NOT NULL REFERENCES trace(id)";

$virtual_clock_col = "virtual_clock $real_fmt NOT NULL";
$all_cand_queue_col = "all_cand_queue $real_fmt NOT NULL";
$all_cand_queue_weighed_col = "all_cand_queue_weighed $real_fmt NOT NULL";
$req_cand_queue_col = "req_cand_queue $real_fmt NOT NULL";
$req_cand_queue_weighed_col = "req_cand_queue_weighed $real_fmt NOT NULL";
$dis_cand_queue_col = "dis_cand_queue $real_fmt NOT NULL";
$dis_cand_queue_weighed_col = "dis_cand_queue_weighed $real_fmt NOT NULL";

$all_res_usage_col = "all_res_usage";
$req_res_usage_col = "req_res_usage";
$dis_res_usage_col = "dis_res_usage";
$scaled_res_usage_col = "scaled_res_usage";
$billable_resources_col = "billable_resources";
$res_busy_range_time_col = "res_busy_range_time $real_fmt NOT NULL";
$res_busy_time_col = "res_busy_time $real_fmt NOT NULL";
$res_idle_time_col = "res_idle_time $real_fmt NOT NULL";
$non_work_cons_time_col = "non_work_cons_time $real_fmt NOT NULL";
$load_col = "load_noclash $real_high_fmt NOT NULL";
$req_load_col = "req_load $real_high_fmt NOT NULL";
$req_load_ignoring_idle_col = "req_load_ignoring_idle $real_high_fmt NOT NULL";

$user_count_col = "user_count INT UNSIGNED NOT NULL";
$num_hit_req_dis_limit_col = "num_hit_req_dis_limit INT UNSIGNED NOT NULL";
$task_sets_col = "task_sets";
$task_sets_alive_time_col = "task_sets_alive_time $real_fmt NOT NULL";
$no_task_sets_alive_time_col = "no_task_sets_alive_time $real_fmt NOT NULL";
$tasks_ready_time_col = "tasks_ready_time $real_fmt NOT NULL";
$disclosed_tasks_col = "disclosed_tasks";
$disclosed_only_tasks_col = "disclosed_only_tasks";
$executed_tasks_col = "executed_tasks";
$requested_tasks_col = "requested_tasks";
$finished_tasks_col = "finished_tasks";
$canceled_tasks_col = "canceled_tasks";

$vrt_col = "vrt";
$vsd_col = "vsd";
$user_vrt_col = "user_vrt";
$user_vsd_col = "user_vsd";
$deadlines_met_col = "deadlines_met";

# analyze cols

use vars qw ( $ana_id_col $ana_trace_input_id_col $ana_metric_order_col
	      $ana_metric_name_col $ana_metric_field_col $ana_baseline_id_col
	      $ana_baseline_val_col $ana_new_id_col $ana_new_val_col
	      $ana_improvement_col );

$ana_id_col = $id_col;
$ana_trace_input_id_col = $trace_input_id_col;
$ana_metric_order_col = "metric_order VARCHAR($ana_metric_order_len) " .
    "BINARY NOT NULL";
$ana_metric_name_col = "metric_name VARCHAR($dist_kind_len) BINARY NOT NULL";
$ana_metric_field_col = "metric_field VARCHAR($dist_kind_len) BINARY NULL";
$ana_baseline_id_col =
    "baseline_id INT UNSIGNED NOT NULL REFERENCES output(id)";
$ana_baseline_val_col = "baseline_val $real_high_fmt NOT NULL";
$ana_new_id_col = "new_id INT UNSIGNED NOT NULL REFERENCES output(id)";
$ana_new_val_col = "new_val $real_high_fmt NOT NULL";
$ana_improvement_col = "improvement $real_fmt NOT NULL";

######################################################################

sub db_connect
{
    my ($db, $loc, $name, $pw) = @_;
    my $str;
    my @option_list;

    # if the loc is the current machine, we may be less efficient than
    # going to 127.0.0.1.  this happens when the ip address is really
    # a NAT router that rewrites the packets to go to a LAN address.
    # don't know a way around this.

    $str = "DBI:mysql:";

    if(defined($db)) {
	push @option_list, "database=$db";
    }
    if(defined($loc)) {
	push @option_list, "host=$loc";
    }
    if(@option_list) {
	$str .= join ';', @option_list;
    }

    $dbh = DBI->connect($str, $name, $pw,
			{ PrintError => 0, RaiseError => 1, AutoCommit => 1 });
    die "couldn't connect to db" if(!defined($dbh));
}

sub db_ba_connect
{
    my ($ba_ver, $loc, $name, $pw) = @_;
    my $db;

    $db = &ver_to_db_name($ba_ver);
    &db_connect($db, $loc, $name, $pw);
}

sub ver_to_db_name
{
    my $ver = shift;
    my $db;

    $ver =~ tr/./_/;
    $db = "ba_$ver";

    return $db;
}

sub db_disconnect
{
    $dbh->disconnect;
    # don't think it returns anything useful under any condition
}

sub db_new_db
{
    my $ver = shift;
    my $db;
    my $ret;

    $db = &ver_to_db_name($ver);

    $ret = $dbh->do("CREATE DATABASE ${db}");
    die "create database should have returned 1" if($ret != 1);
    $ret = $dbh->do("GRANT ALL PRIVILEGES ON ${db}.* TO dpetrou");
    die "grant privileges to dpetrou should have returned 0" if($ret != 0);
    $ret = $dbh->do("USE ${db}");
    die "use db should have returned 0" if($ret != 0);

    &make_trace_table;
    &make_output_table;
    &make_analyze_table;

    print "created db $db.\n";
}

sub db_renew_db
{
    my $ver = shift;
    my $db;
    my $ret;

    $db = &ver_to_db_name($ver);

    $ret = $dbh->do("DROP DATABASE ${db}");
    die "drop database should have returned 1" if($ret != 0);

    print "removed db $db.\n";

    &db_new_db($ver);
}

sub select_generic_where_project_count
{
    my $table = shift;
    my $where = shift;
    my $select_str;
    my @set;
    my $sth;
    my $col_list;
    my $ret;
    my $where_str;
    my $count;
    my @row;

    $where_str = &make_where_str($where);
    $select_str = "SELECT count(*) FROM $table $where_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret != 1);

    @row = $sth->fetchrow_array;
    die "huh?" if(@row != 1);
    $count = $row[0];
    @row = $sth->fetchrow_array;
    die "huh?" if(@row != 0);

    return $count;
}

sub make_where_str
{
    my @wheres = @_;
    my @nice_wheres;
    my $where_str;

    die "should have gotten at least one elem, even if it was undef'd"
	if(@wheres == 0);

    foreach my $where (@wheres) {
	if(defined($where)) {
	    if($where ne "") {
		push @nice_wheres, $where;
	    }
	}
    }

    if(@nice_wheres) {
	$where_str = "WHERE " . join " AND ", @nice_wheres;
    } else {
	$where_str = "";
    }

    return $where_str;
}

sub to_db_shared
{
    my $info = shift;
    my ( $program, $version, $hostname, $args, $datetime, $random_seed,
	 $trace_input, $trace_output );

    die "hostname too big" if(length(&get_hostname) > $hostname_len);

    ($program, $version) = &to_db_program($info->{program});
    $hostname = $dbh->quote(&get_hostname);
    $args = $dbh->quote($info->{args});
    $datetime = &to_db_run_date($info->{run_date});
    $random_seed = $info->{random_seed};
#    die "bad random seed" if(&ba_harness_random_seed_get != $random_seed);
    $trace_input = &to_db_none_to_null($info->{trace_input});
    $trace_output = &to_db_none_to_null($info->{trace_output});

    return ( $program, $version, $hostname, $args, $datetime, $random_seed,
	     $trace_input, $trace_output );
}

sub to_db_program
{
    my $in_prog = shift;
    my ($program, $version);

    if($in_prog =~ /^(\w+)\s+(\S+)$/) {
	$program = $1;
	$version = $2;
    } else {
	die "can't parse program `$in_prog'";
    }

    die "bad prog" if(&ba_harness_prog_get ne $program);
    die "bad ver" if(&ba_harness_ver_get != $version);

    die "program too big" if(length($program) > $program_len);
    die "version too big" if(length($version) > $version_len);

    return ($dbh->quote($program), $dbh->quote($version));
}

sub to_db_none_to_null
{
    my $str = shift;

    if($str eq "(none)") {
	return "NULL";
    } else {
	return $dbh->quote($str);
    }
}

sub to_db_undef_to_null
{
    my $str = shift;

    if(!defined($str)) {
	return "NULL";
    } else {
	return $dbh->quote($str);
    }
}

sub to_db_run_date
{
    my $run_date = shift;
    my $datetime;
    my ( $year, $month_name, $month, $day );
    my ( $hour, $minute, $second );

    if($run_date =~
       /^UTC\s+(\w+)\s+(\w+)\s+(\d+)\s+(\d+):(\d+):(\d+)\s+(\d+)$/) {
	$month_name = $2;
	$day = $3;
	$hour = $4;
	$minute = $5;
	$second = $6;
	$year = $7;
    } else {
	die "couldn't parse date";
    }

    if($month_name eq "Jan") {
	$month = 1;
    } elsif($month_name eq "Feb") {
	$month = 2;
    } elsif($month_name eq "Mar") {
	$month = 3;
    } elsif($month_name eq "Apr") {
	$month = 4;
    } elsif($month_name eq "May") {
	$month = 5;
    } elsif($month_name eq "Jun") {
	$month = 6;
    } elsif($month_name eq "Jul") {
	$month = 7;
    } elsif($month_name eq "Aug") {
	$month = 8;
    } elsif($month_name eq "Sep") {
	$month = 9;
    } elsif($month_name eq "Oct") {
	$month = 10;
    } elsif($month_name eq "Nov") {
	$month = 11;
    } elsif($month_name eq "Dec") {
	$month = 12;
    } else {
	die "couldn't parse month `$month_name'"
    }

    $datetime = "$year-$month-$day $hour:$minute:$second";

    return $dbh->quote($datetime);
}

sub from_db_shared
{
    my $row = shift;
    my ($id, $program, $args, $run_date, $random_seed, $trace_input,
	$trace_output);

    # db specific (not in original ba_sim run):
    $id = shift @$row;

    $program = shift @$row;
    $program .= " " . shift @$row;
    
    shift @$row; # hostname

    $args = shift @$row;
    $run_date = shift @$row; # not converting back to orig fmt
    $random_seed = shift @$row;

    $trace_input = &from_db_null_to_none(shift @$row);
    $trace_output = &from_db_null_to_none(shift @$row);

    return ($id, $program, $args, $run_date, $random_seed, $trace_input,
	    $trace_output);
}

sub from_db_null_to_none
{
    my $str = shift;

    if(!defined($str)) {
	return "(none)";
    } else {
	return $str;
    }
}

sub from_db_null_to_undef
{
    my $str = shift;

    # just works.
    return $str; 
}

sub db_lock_tables
{
    my $str;
    my $ret;

    $str = join(",",
		"trace write",
		"trace AS t write",
		"output write",
		"output AS o write",
		"output AS baseline write",
		"output AS new write",
		"output AS o1 write",
		"output AS o2 write",
		"analysis write",
		"analysis AS a write",
		"analysis AS a1 write",
		"analysis AS a2 write");

    $ret = $dbh->do("LOCK TABLES $str");
    die "lock should have returned 0" if $ret != 0;
}

sub db_unlock_tables
{
    my $ret;

    $ret = $dbh->do("UNLOCK TABLES");
    die "unlock should have returned 0" if $ret != 0;
}

######################################################################

# trace stuff

sub make_trace_table
{
    my ($cols_str, $keys_str, $str);
    my $ret;

    $cols_str = &get_complete_trace_cols_types;

    $keys_str = join(",",
		     "PRIMARY KEY (id)",
		     &make_key_str("program"),
		     &make_key_str("hostname"),
		     &make_key_str("version"),
		     &make_key_str("run_date"),
		     &make_key_str("random_seed"),
		     &make_key_str("num_users"),
		     &make_key_str("virtual_clock_terminate"),
		     &make_key_str("max_req_dis_tasks_per_user"),
		     &make_dist_key_str("user_arrivals"),
		     &make_dist_key_str("task_set_change_range"),
		     &make_dist_key_str("tasks_per_task_set"),
		     &make_dist_key_str("service_time"),
		     &make_dist_key_str("think_time"));
    $str = "CREATE TABLE trace ( $cols_str, $keys_str ) " .
		    "TYPE=MyISAM";
    $ret = $dbh->do($str);
    die "create table should have returned 0" if($ret != 0);
}

sub db_insert_trace
{
    my $parsed_trace = shift;
    my ( $program, $version, $hostname, $args, $datetime, $random_seed,
	 $trace_input, $trace_output,
	 $num_users, $virtual_clock_terminate,
	 $max_req_dis_tasks_per_user,
	 $user_arrivals, $task_set_change_range, $tasks_per_task_set,
	 $service_time, $think_time );
    my $str;
    my $col_list;
    my $count;
    
    ($program, $version, $hostname, $args, $datetime, $random_seed,
     $trace_input, $trace_output) = &to_db_shared($parsed_trace);
    ($num_users, $virtual_clock_terminate,
     $max_req_dis_tasks_per_user,
     $user_arrivals, $task_set_change_range, $tasks_per_task_set,
     $service_time, $think_time) = &to_db_trace_stuff($parsed_trace);

    $str = join(',', "NULL", $program, $version, $hostname, $args,
		$datetime, $random_seed, $trace_input, $trace_output,
		$num_users, $virtual_clock_terminate,
		$max_req_dis_tasks_per_user,
		$user_arrivals, $task_set_change_range,
		$tasks_per_task_set, $service_time, $think_time);

    $col_list = &get_complete_trace_cols;
    $count = $dbh->do("INSERT trace ( $col_list ) VALUES ( $str )");
    die "bad count" if($count != 1);

    return $dbh->{mysql_insertid};
}

sub db_update_trace
{
    my $id = shift;
    my $parsed_trace = shift;
    my ( $hostname, $args, $datetime, $trace_output );
    my $count;

    (undef, undef, $hostname, $args, $datetime, undef, undef, $trace_output) =
	&to_db_shared($parsed_trace);

    $count = $dbh->do("UPDATE trace SET args = $args, hostname = $hostname, " .
		      "run_date = $datetime, trace_output = $trace_output " .
		      "WHERE trace.id = $id");
    die "bad count" if($count != 1);
}

# unused anywhere
sub db_delete_trace
{
    my $id = shift;
    my $count;

    $count = $dbh->do("DELETE FROM trace WHERE trace.id = $id");
    die "bad count" if $count != 1;
}

sub db_select_trace_id
{
    my $id = shift;
    my $sth;
    my @row;
    my $col_list;
    my $ret;
    my $select_str;

    $col_list = &get_complete_trace_cols;
    $select_str = "SELECT $col_list FROM trace WHERE trace.id = $id";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret != 1);
    @row = $sth->fetchrow_array;
    die "couldn't find output id `$id'" if(!@row);
    die "too many rows" if(defined($sth->fetchrow_array));

    return &trace_db_to_trace_hash(\@row);
}

sub db_select_trace_where_project_count
{
    my $where = shift;

    return &select_generic_where_project_count("trace", $where);
}

# only used locally right now
sub db_select_trace_where
{
    my ($alias, $where) = @_;
    my (@set, $sth, $ret);
    my ($col_list, $where_str, $select_str);

    $col_list = &get_complete_trace_cols;
    $where_str = &make_where_str($where);
    $select_str = "SELECT $col_list FROM trace AS $alias $where_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret < 0);

    while(1) {
	my @row;

	@row = $sth->fetchrow_array;
	if(@row == 0) {
	    last;
	}
	push @set, &trace_db_to_trace_hash(\@row);
    }

    return \@set;
}

sub db_select_trace_where_ids
{
    my ($alias, $where, $ids) = @_;
    my $new_where;

    # cleaner to have this `where' business handled by make_where_str,
    # but were're at the wrong level of abstraction.
    if(defined($where)) {
	$new_where = $where . " AND ";
    } else {
	$new_where = "";
    }

    $new_where .= "id IN ( " . join(",", @$ids) . ")";

    return &db_select_trace_where($alias, $new_where);
}

sub trace_db_to_trace_hash
{
    my $row = shift;
    my %parsed_trace;

    ($parsed_trace{id}, $parsed_trace{program}, $parsed_trace{args},
     $parsed_trace{run_date},
     $parsed_trace{random_seed}, $parsed_trace{trace_input},
     $parsed_trace{trace_output}) = &from_db_shared($row);

    $parsed_trace{num_users} = shift @$row;
    $parsed_trace{virtual_clock_terminate} = shift @$row;
    $parsed_trace{max_req_dis_tasks_per_user} = shift @$row;
    &dist_row_to_hash($row, \%parsed_trace, "user_arrivals");
    &dist_row_to_hash($row, \%parsed_trace, "task_set_change_range");
    &dist_row_to_hash($row, \%parsed_trace, "tasks_per_task_set");
    &dist_row_to_hash($row, \%parsed_trace, "service_time");
    &dist_row_to_hash($row, \%parsed_trace, "think_time");

    die "elems remaining" if(@$row);

    return \%parsed_trace;
}

sub dist_row_to_hash
{
    my ($row, $hash, $name) = @_;
    my ($kind, $alpha, $beta, $mean, $prob);
    
    $kind = shift @$row;
    $alpha = shift @$row;
    $beta = shift @$row;
    $mean = shift @$row;
    $prob = shift @$row;

    $hash->{$name} = &dist_str_from_args($kind, $alpha, $beta, $mean, $prob);
    $hash->{"${name}_kind"} = $kind;
    $hash->{"${name}_alpha"} = $alpha;
    $hash->{"${name}_beta"} = $beta;
    $hash->{"${name}_mean"} = $mean;
    $hash->{"${name}_prob"} = $prob;
}

sub to_db_trace_stuff
{
    my $parsed_trace = shift;
    my ( $num_users, $virtual_clock_terminate,
	 $max_req_dis_tasks_per_user,
	 $user_arrivals, $task_set_change_range, $tasks_per_task_set,
	 $service_time, $think_time );

    $num_users = $parsed_trace->{num_users};
    $virtual_clock_terminate = $parsed_trace->{virtual_clock_terminate};
    $max_req_dis_tasks_per_user =
	$parsed_trace->{max_req_dis_tasks_per_user};
    $user_arrivals = &to_db_dist($parsed_trace->{user_arrivals});
    $task_set_change_range =
	&to_db_dist($parsed_trace->{task_set_change_range});
    $tasks_per_task_set = &to_db_dist($parsed_trace->{tasks_per_task_set});
    $service_time = &to_db_dist($parsed_trace->{service_time});
    $think_time = &to_db_dist($parsed_trace->{think_time});

    return ( $num_users, $virtual_clock_terminate,
	     $max_req_dis_tasks_per_user,
	     $user_arrivals, $task_set_change_range, $tasks_per_task_set,
	     $service_time, $think_time );
}

sub db_find_trace_id
{
    my ($use_hostname, $num_users_in, $virtual_clock_terminate_in,
	$max_req_dis_tasks_per_user_in, $user_arrivals_in,
	$task_set_change_range_in, $tasks_per_task_set_in, $service_time_in,
	$think_time_in) = @_;
    my ($program_in, $random_seed_in);
    my ($program, $version, $hostname, $random_seed,
	$num_users, $virtual_clock_terminate,
	$max_req_dis_tasks_per_user,
	$user_arrivals_comp, $task_set_change_range_comp,
	$tasks_per_task_set_comp, $service_time_comp, $think_time_comp);
    my $trace_id;
    my $sth;
    my @row;
    my $ret;
    my $str;
    my $select_str;

    $program_in = &ba_harness_prog_get . " " . &ba_harness_ver_get;

# i only want to comp random seed on local tracing. XXX
#    $random_seed_in = &ba_harness_random_seed_get;
 
    ($program, $version) = &to_db_program($program_in);
    $hostname = $dbh->quote(&get_hostname);
#    $random_seed = $random_seed_in;

    $num_users = $num_users_in;
    $virtual_clock_terminate = $virtual_clock_terminate_in;
    $max_req_dis_tasks_per_user = $max_req_dis_tasks_per_user_in;
    $user_arrivals_comp = &to_db_dist_comp($user_arrivals_in,
						"user_arrivals");
    $task_set_change_range_comp = &to_db_dist_comp($task_set_change_range_in,
						   "task_set_change_range");
    $tasks_per_task_set_comp = &to_db_dist_comp($tasks_per_task_set_in,
						"tasks_per_task_set");
    $service_time_comp = &to_db_dist_comp($service_time_in, "service_time");
    $think_time_comp = &to_db_dist_comp($think_time_in,	"think_time");

    $str = join(" AND ", "t.program = $program", "t.version = $version");
    if($use_hostname) {
	$str = join(" AND ", $str, "t.hostname = $hostname");
    }
    $str = join(" AND ", $str,
#		"t.random_seed = $random_seed",
		"t.num_users = $num_users",
		"t.virtual_clock_terminate = $virtual_clock_terminate",
		"t.max_req_dis_tasks_per_user = " .
		"$max_req_dis_tasks_per_user",
		"$user_arrivals_comp",
		"$task_set_change_range_comp",
		"$tasks_per_task_set_comp",
		"$service_time_comp",
		"$think_time_comp");

    $select_str = "SELECT id FROM trace t WHERE $str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret > 1 || $ret < 0);
    @row = $sth->fetchrow_array;
    if(!@row) {
	return undef;
    }
    $trace_id = $row[0];
    die "too many rows" if(defined($sth->fetchrow_array));

    return $trace_id;
}

######################################################################

# output stuff

sub make_output_table
{
    my $cols_str;
    my $ret;
    my $keys_str;
    my $str;

    $cols_str = &get_complete_output_cols_types;

    $keys_str = join(",",
		     "PRIMARY KEY (id)",
		     &make_key_str("trace_input_id"),
		     &make_key_str("dis_sched"),
		     &make_key_str("req_sched"));

    $str = "CREATE TABLE output ( " . $cols_str . ", $keys_str ) " .
	"TYPE=MyISAM";
    $ret = $dbh->do($str);
    die "create table should have returned 0" if($ret != 0);
}

sub db_insert_output
{
    my $parsed_output = shift;
    my $trace_input_id = shift;
    my ( $program, $version, $hostname, $args, $datetime, $random_seed,
	 $treat_req_dis_diff, $req_sched, $dis_sched, $trace_input,
	 $trace_output, $virtual_clock, $all_cand_queue,
	 $all_cand_queue_weighed, $req_cand_queue, $req_cand_queue_weighed,
	 $dis_cand_queue, $dis_cand_queue_weighed, $all_res_usage,
	 $req_res_usage,
	 $dis_res_usage, $scaled_res_usage, $billable_resources,
	 $res_busy_range_time,
	 $res_busy_time, $res_idle_time, $non_work_cons_time, $load,
	 $req_load, $req_load_ignoring_idle,
	 $user_count, $num_hit_req_dis_limit, $task_sets,
	 $task_sets_alive_time, $no_task_sets_alive_time, $tasks_ready_time,
	 $disclosed_tasks, $disclosed_only_tasks, $executed_tasks,
	 $requested_tasks, $finished_tasks, $canceled_tasks,
	 $vrt, $vsd, $user_vrt, $user_vsd, $deadlines_met );
    my $val_str;
    my $col_list;
    my $count;
    my $select_str;

    ($program, $version, $hostname, $args, $datetime, $random_seed,
     $trace_input,
     $trace_output) = &to_db_shared($parsed_output);
    ($treat_req_dis_diff, $req_sched, $dis_sched, $virtual_clock,
     $all_cand_queue, $all_cand_queue_weighed, $req_cand_queue,
     $req_cand_queue_weighed, $dis_cand_queue, $dis_cand_queue_weighed,
     $all_res_usage, $req_res_usage, $dis_res_usage, $scaled_res_usage,
     $billable_resources, $res_busy_range_time, $res_busy_time,
     $res_idle_time,
     $non_work_cons_time, $load, $req_load, $req_load_ignoring_idle,
     $user_count, $num_hit_req_dis_limit, $task_sets,
     $task_sets_alive_time, $no_task_sets_alive_time, $tasks_ready_time,
     $disclosed_tasks, $disclosed_only_tasks, $executed_tasks,
     $requested_tasks, $finished_tasks, $canceled_tasks, $vrt, $vsd,
     $user_vrt, $user_vsd, $deadlines_met) =
	 &to_db_output_stuff($parsed_output);
    
    $val_str = join(',', "NULL", $program, $version, $hostname, $args,
		$datetime, $random_seed, $trace_input, $trace_output,
		$trace_input_id,
		$treat_req_dis_diff, $req_sched,
		$dis_sched,
		$virtual_clock, $all_cand_queue, $all_cand_queue_weighed,
		$req_cand_queue, $req_cand_queue_weighed, $dis_cand_queue,
		$dis_cand_queue_weighed, $all_res_usage, $req_res_usage,
		$dis_res_usage,
		$scaled_res_usage, $billable_resources, $res_busy_range_time,
		$res_busy_time,
		$res_idle_time, $non_work_cons_time, $load, $req_load,
		$req_load_ignoring_idle, $user_count,
		$num_hit_req_dis_limit, $task_sets, $task_sets_alive_time,
		$no_task_sets_alive_time, $tasks_ready_time,
		$disclosed_tasks, $disclosed_only_tasks, $executed_tasks,
		$requested_tasks, $finished_tasks, $canceled_tasks,
		$vrt, $vsd, $user_vrt, $user_vsd, $deadlines_met);

    $col_list = &get_complete_output_cols;

    $select_str = "INSERT output ( $col_list ) VALUES ( $val_str )";
    $count = $dbh->do($select_str);
    die "bad count" if($count != 1);

    return $dbh->{mysql_insertid};
}

sub db_update_output
{
    my $id = shift;
    my $parsed_output = shift;
    my $count;

    my ( $program, $version, $hostname, $args, $datetime, $random_seed,
	 $trace_input, $trace_output );

    ($program, $version, $hostname, $args, $datetime, $random_seed,
     $trace_input, $trace_output) = &to_db_shared($parsed_output);

    $count = $dbh->do("UPDATE output SET args = $args, " .
		      "hostname = $hostname, run_date = $datetime " .
		      "WHERE output.id = $id");
    die "bad count" if($count != 1);
}

sub db_select_output_id
{
    my $id = shift;
    my $sth;
    my @row;
    my $col_list;
    my $ret;

    $col_list = &get_complete_output_cols;
    $sth = $dbh->prepare("SELECT $col_list FROM output WHERE output.id = $id");
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret != 1);
    @row = $sth->fetchrow_array;
    die "couldn't find output id `$id'" if(!@row);
    die "too many rows" if(defined($sth->fetchrow_array));

    return &output_db_to_output_hash(\@row);
}

sub db_select_output_where_project_count
{
    my $where = shift;

    return &select_generic_where_project_count("output", $where);
}

# only used locally right now
sub db_select_output_where
{
    my $alias = shift;
    my $where = shift;
    my $select_str;
    my @set;
    my $sth;
    my $col_list;
    my $ret;
    my $where_str;

    $col_list = &get_complete_output_cols;
    $where_str = &make_where_str($where);
    $select_str = "SELECT $col_list FROM output AS $alias $where_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret < 0);

    while(1) {
	my @row;

	@row = $sth->fetchrow_array;
	if(@row == 0) {
	    last;
	}
	push @set, &output_db_to_output_hash(\@row);
    }

    return \@set;
}

sub db_select_output_where_ids
{
    my ($alias, $where, $ids) = @_;
    my $new_where;

    # cleaner to have this `where' business handled by make_where_str,
    # but were're at the wrong level of abstraction.
    if(defined($where)) {
	$new_where = $where . " AND ";
    } else {
	$new_where = "";
    }

    $new_where .= "id IN ( " . join(",", @$ids) . ")";

    return &db_select_output_where($alias, $new_where);
}

sub db_select_output_where_trace_input_ids
{
    my ($alias, $where, $trace_ids) = @_;
    my $new_where;

    # cleaner to have this `where' business handled by make_where_str,
    # but were're at the wrong level of abstraction.
    if(defined($where)) {
	$new_where = $where . " AND ";
    } else {
	$new_where = "";
    }

    $new_where .= "trace_input_id IN ( " .
	join(",", @$trace_ids) .
	")";

    return &db_select_output_where($alias, $new_where);
}

# unused
sub db_select_output_where_project_trace_input_id
{
    my $where = shift;
    my $select_str;
    my @set;
    my $sth;
    my $col_list;
    my $ret;
    my $where_str;

    $where_str = &make_where_str($where);
    $select_str = "SELECT DISTINCT trace_input_id FROM output $where_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret < 0);

    while(1) {
	my @row;

	@row = $sth->fetchrow_array;
	if(@row == 0) {
	    last;
	}
	die "here, @row must have one elem" if @row != 1;
	push @set, $row[0];
    }

    return \@set;
}

sub db_get_trace_id_with_constraints
{
    my $where_baseline = shift;
    my $where_new = shift;
    my $where_trace_restrict = shift;
    my $select_str;
    my @set;
    my $sth;
    my $col_list;
    my $ret;
    my $where_str;

    $where_str =
	&make_where_str("baseline.trace_input_id = new.trace_input_id",
			"baseline.trace_input_id = trace.id",
			$where_baseline,
			$where_new,
			$where_trace_restrict);
    $select_str = "SELECT DISTINCT trace.id " .
	"FROM output AS baseline, output AS new, trace $where_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret < 0);

    while(1) {
	my @row;

	@row = $sth->fetchrow_array;
	if(@row == 0) {
	    last;
	}
	die "here, @row must have one elem" if @row != 1;
	push @set, $row[0];
    }

    return \@set;
}

sub output_db_to_output_hash
{
    my $row = shift;
    my %parsed_output;

    ($parsed_output{id},
     $parsed_output{program}, $parsed_output{args}, $parsed_output{run_date},
     $parsed_output{random_seed}, $parsed_output{trace_input},
     $parsed_output{trace_output}) = &from_db_shared($row);

    # db specific (not in original ba_sim run):
    $parsed_output{trace_input_id} = shift @$row;

    $parsed_output{treat_req_dis_diff} = shift @$row;
    $parsed_output{req_sched} = shift @$row;
    $parsed_output{dis_sched} = shift @$row;

    $parsed_output{virtual_clock} = shift @$row;
    $parsed_output{all_cand_queue} = shift @$row;
    $parsed_output{all_cand_queue_weighed} = shift @$row;
    $parsed_output{req_cand_queue} = shift @$row;
    $parsed_output{req_cand_queue_weighed} = shift @$row;
    $parsed_output{dis_cand_queue} = shift @$row;
    $parsed_output{dis_cand_queue_weighed} = shift @$row;

    $parsed_output{all_res_usage} = &list_to_stats($row);
    $parsed_output{req_res_usage} = &list_to_stats($row);
    $parsed_output{dis_res_usage} = &list_to_stats($row);
    $parsed_output{scaled_res_usage} = &list_to_stats($row);
    $parsed_output{billable_resources} = &list_to_stats($row);
    $parsed_output{res_busy_range_time} = shift @$row;
    $parsed_output{res_busy_time} = shift @$row;
    $parsed_output{res_idle_time} = shift @$row;
    $parsed_output{non_work_cons_time} = shift @$row;
    $parsed_output{load} = shift @$row;
    $parsed_output{req_load} = shift @$row;
    $parsed_output{req_load_ignoring_idle} = shift @$row;

    $parsed_output{user_count} = shift @$row;
    $parsed_output{num_hit_req_dis_limit} = shift @$row;
    $parsed_output{task_sets} = &list_to_stats($row);
    $parsed_output{task_sets_alive_time} = shift @$row;
    $parsed_output{no_task_sets_alive_time} = shift @$row;
    $parsed_output{tasks_ready_time} = shift @$row;
    $parsed_output{disclosed_tasks} = &list_to_stats($row);
    $parsed_output{disclosed_only_tasks} = &list_to_stats($row);
    $parsed_output{executed_tasks} = &list_to_stats($row);
    $parsed_output{requested_tasks} = &list_to_stats($row);
    $parsed_output{finished_tasks} = &list_to_stats($row);
    $parsed_output{canceled_tasks} = &list_to_stats($row);

    $parsed_output{vrt} = &list_to_stats($row);
    $parsed_output{vsd} = &list_to_stats($row);
    $parsed_output{user_vrt} = &list_to_stats($row);
    $parsed_output{user_vsd} = &list_to_stats($row);
    $parsed_output{deadlines_met} = &list_to_stats($row);

    die "elems remaining" if(@$row);

    return \%parsed_output;
}

sub to_db_output_stuff
{
    my $parsed_output = shift;
    my ($treat_req_dis_diff, $req_sched, $dis_sched, $virtual_clock,
	$all_cand_queue, $all_cand_queue_weighed, $req_cand_queue,
	$req_cand_queue_weighed, $dis_cand_queue, $dis_cand_queue_weighed,
	$all_res_usage, $req_res_usage, $dis_res_usage, $scaled_res_usage,
	$billable_resources,
	$res_busy_range_time, $res_busy_time, $res_idle_time,
	$non_work_cons_time, $load, $req_load, $req_load_ignoring_idle,
	$user_count, $num_hit_req_dis_limit, $task_sets,
	$task_sets_alive_time, $no_task_sets_alive_time, $tasks_ready_time,
	$disclosed_tasks, $disclosed_only_tasks, $executed_tasks,
	$requested_tasks, $finished_tasks, $canceled_tasks, $vrt, $vsd,
	$user_vrt, $user_vsd, $deadlines_met);

    die "req_sched too big"
	if(length($parsed_output->{req_sched}) > $sched_len);
    die "dis_sched too big"
	if(length($parsed_output->{dis_sched}) > $sched_len);

    $treat_req_dis_diff = $parsed_output->{treat_req_dis_diff};
    $req_sched = $dbh->quote($parsed_output->{req_sched});
    $dis_sched = $dbh->quote($parsed_output->{dis_sched});

    $virtual_clock = $parsed_output->{virtual_clock};
    $all_cand_queue = $parsed_output->{all_cand_queue};
    $all_cand_queue_weighed = $parsed_output->{all_cand_queue_weighed};
    $req_cand_queue = $parsed_output->{req_cand_queue};
    $req_cand_queue_weighed = $parsed_output->{req_cand_queue_weighed};
    $dis_cand_queue = $parsed_output->{dis_cand_queue};
    $dis_cand_queue_weighed = $parsed_output->{dis_cand_queue_weighed};

    $all_res_usage = join(',', @{$parsed_output->{all_res_usage}});
    $req_res_usage = join(',', @{$parsed_output->{req_res_usage}});
    $dis_res_usage = join(',', @{$parsed_output->{dis_res_usage}});
    $scaled_res_usage = join(',', @{$parsed_output->{scaled_res_usage}});
    $billable_resources = join(',', @{$parsed_output->{billable_resources}});
    $res_busy_range_time = $parsed_output->{res_busy_range_time};
    $res_busy_time = $parsed_output->{res_busy_time};
    $res_idle_time = $parsed_output->{res_idle_time};
    $non_work_cons_time = $parsed_output->{non_work_cons_time};
    $load = $parsed_output->{load};
    $req_load = $parsed_output->{req_load};
    $req_load_ignoring_idle = $parsed_output->{req_load_ignoring_idle};

    $user_count = $parsed_output->{user_count};
    $num_hit_req_dis_limit = $parsed_output->{num_hit_req_dis_limit};
    $task_sets = join(',', @{$parsed_output->{task_sets}});
    $task_sets_alive_time = $parsed_output->{task_sets_alive_time};
    $no_task_sets_alive_time = $parsed_output->{no_task_sets_alive_time};
    $tasks_ready_time = $parsed_output->{tasks_ready_time};
    $disclosed_tasks = join(',', @{$parsed_output->{disclosed_tasks}});
    $disclosed_only_tasks = join(',',
				 @{$parsed_output->{disclosed_only_tasks}});
    $executed_tasks = join(',', @{$parsed_output->{executed_tasks}});
    $requested_tasks = join(',', @{$parsed_output->{requested_tasks}});
    $finished_tasks = join(',', @{$parsed_output->{finished_tasks}});
    $canceled_tasks = join(',', @{$parsed_output->{canceled_tasks}});

    $vrt = join(',', @{$parsed_output->{vrt}});
    $vsd = join(',', @{$parsed_output->{vsd}});
    $user_vrt = join(',', @{$parsed_output->{user_vrt}});
    $user_vsd = join(',', @{$parsed_output->{user_vsd}});
    $deadlines_met = join(',', @{$parsed_output->{deadlines_met}});

    return ($treat_req_dis_diff, $req_sched, $dis_sched, $virtual_clock,
	    $all_cand_queue, $all_cand_queue_weighed, $req_cand_queue,
	    $req_cand_queue_weighed, $dis_cand_queue, $dis_cand_queue_weighed,
	    $all_res_usage, $req_res_usage, $dis_res_usage, $scaled_res_usage,
	    $billable_resources,
	    $res_busy_range_time, $res_busy_time, $res_idle_time,
	    $non_work_cons_time, $load, $req_load, $req_load_ignoring_idle,
	    $user_count, $num_hit_req_dis_limit, $task_sets,
	    $task_sets_alive_time, $no_task_sets_alive_time, $tasks_ready_time,
	    $disclosed_tasks, $disclosed_only_tasks, $executed_tasks,
	    $requested_tasks, $finished_tasks, $canceled_tasks, $vrt, $vsd,
	    $user_vrt, $user_vsd, $deadlines_met);
}

sub db_find_output_id
{
    my ($trace_input_id_in, $random_seed_in, $req_sched_in, $dis_sched_in)
	= @_;
    my $program_in;
    my ($program, $version, $random_seed, $trace_input_id,
	$req_sched, $dis_sched);
    my $sth;
    my @row;
    my $id;
    my $ret;
    my $str;
    my $select_str;

    $program_in = &ba_harness_prog_get . " " . &ba_harness_ver_get;
#    $random_seed_in = &ba_harness_random_seed_get;
 
    ($program, $version) = &to_db_program($program_in);
    $random_seed = $random_seed_in;

    $trace_input_id = $trace_input_id_in;
    $req_sched = $dbh->quote($req_sched_in);
    $dis_sched = $dbh->quote($dis_sched_in);

    # don't need to check treat_req_dis_diff...  checking req_sched
    # and dis_sched disambiguates all.

    $str = join(" AND ", "o.program = $program",
		"o.version = $version",
		"o.random_seed = $random_seed",
		"o.trace_input_id = $trace_input_id",
		"o.req_sched = $req_sched",
		"o.dis_sched = $dis_sched");
    $select_str = "SELECT id FROM output o WHERE $str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret > 1 || $ret < 0);
    @row = $sth->fetchrow_array;
    if(!@row) {
	return undef;
    }
    $id = $row[0]; 
    die "too many rows" if(defined($sth->fetchrow_array));

    return $id;
}

######################################################################

# analyze stuff

sub make_analyze_table
{
    my $str;
    my $ret;
    my $keys_str;

    $str = &get_complete_analyze_cols_types;

    $keys_str = join(",",
		     "PRIMARY KEY (id)",
		     &make_key_str("trace_input_id"),
		     &make_key_str("baseline_id"),
		     &make_key_str("new_id"));

    # called analysis, not analyze, because the latter is a mysql keyword!
    $ret = $dbh->do("CREATE TABLE analysis ( " . $str . ", $keys_str ) " .
		    "TYPE=MyISAM");
    die "create table should have returned 0" if($ret != 0);
}

sub db_insert_analyze
{
    my $analyze = shift;
    my ($trace_input_id, $metric_order, $metric_name, $metric_field,
	$baseline_id, $baseline_val, $new_id, $new_val, $improvement);
    my ($col_list, $values_str);
    my $count;

    $col_list = &get_complete_analyze_cols;

    ($trace_input_id, $metric_order, $metric_name, $metric_field,
     $baseline_id, $baseline_val, $new_id, $new_val, $improvement) =
	 &to_db_analyze_stuff($analyze);

    $values_str = join(',', "NULL", $trace_input_id, $metric_order,
		       $metric_name, $metric_field, $baseline_id,
		       $baseline_val, $new_id, $new_val, $improvement);

    $count = $dbh->do("INSERT analysis ( $col_list ) VALUES ( $values_str )");
    die "bad count" if($count != 1);

    return $dbh->{mysql_insertid};
}

sub db_select_analyze_id
{
    my $id = shift;
    my ($sth, @row, $ret);
    my $col_list;

    $col_list = &get_complete_analyze_cols;
    $sth = $dbh->prepare("SELECT $col_list FROM analysis " .
			 "WHERE analysis.id = $id");
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret != 1);
    @row = $sth->fetchrow_array;
    die "couldn't find output id `$id'" if(!@row);
    die "too many rows" if(defined($sth->fetchrow_array));

    return &analyze_db_to_analyze_hash(\@row);
}

sub db_select_analyze_where_project_count
{
    my $where = shift;

    return &select_generic_where_project_count("analysis", $where);
}

# only used locally right now
sub db_select_analyze_where
{
    my ($alias, $where) = @_;
    my (@set, $sth, $ret);
    my ($col_list, $where_str, $select_str);

    $col_list = &get_complete_analyze_cols;
    $where_str = &make_where_str($where);
    $select_str = "SELECT $col_list FROM analysis AS $alias $where_str";
#    print STDERR "$select_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret < 0);

    while(1) {
	my @row;

	@row = $sth->fetchrow_array;
	if(@row == 0) {
	    last;
	}
	push @set, &analyze_db_to_analyze_hash(\@row);
    }

    return \@set;
}

sub db_select_analyze_where_ids
{
    my ($alias, $where, $ids) = @_;
    my $new_where;

    # cleaner to have this `where' business handled by make_where_str,
    # but were're at the wrong level of abstraction.
    if(defined($where)) {
	$new_where = $where . " AND ";
    } else {
	$new_where = "";
    }

    $new_where .= "id IN ( " . join(",", @$ids) . ")";

    return &db_select_analyze_where($alias, $new_where);
}

sub db_select_analyze_for_compare_ba
{
    my $ids = shift;
    my (@set, $sth, $ret);
    my ($col_str, $from_str, $in1_ids_str, $in2_ids_str, $where_str,
	$select_str);

    $col_str = "a1.baseline_id, a1.baseline_val, a1.improvement, " .
	"a1.new_id, a1.new_val, " .
	"a2.baseline_id, a2.baseline_val, a2.improvement, " .
	"a1.trace_input_id";
    $from_str = "FROM analysis as a1, analysis as a2, output as o1, " .
	"output as o2";
    $in1_ids_str = "a1.id IN ( " . join(",", @$ids) . ")";
    $in2_ids_str = "a2.id IN ( " . join(",", @$ids) . ")";
    $where_str = "WHERE" .
	join(" AND ", " a1.trace_input_id = a2.trace_input_id",
	     "a1.new_id = a2.new_id",
	     "a1.baseline_id = o1.id",
	     "a2.baseline_id = o2.id",
	     "o1.dis_sched = \"NOOP\"",
	     "o2.dis_sched = \"n/a\"",
#	     "o1.dis_sched = \"HRP\"",
#	     "o2.dis_sched = \"HRR\"",
	     $in1_ids_str,
	     $in2_ids_str);

    # i don't need extra restrictions on metric between a1 and a2 or
    # to ensure that the new_id is batchactive, because i check these
    # in compareb_ba_checks in ba_present right before making this
    # call.

    $select_str = "SELECT $col_str $from_str $where_str";

#    print STDERR "$select_str\n";

    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret < 0);

    while(1) {
	my @row;

	@row = $sth->fetchrow_array;
	if(@row == 0) {
	    last;
	}
	push @set, \@row;
    }

    return \@set;
}

sub analyze_db_to_analyze_hash
{
    my $row = shift;
    my %analyze;

    # db specific (not in original ba_sim run):
    $analyze{id} = shift @$row;
    $analyze{trace_input_id} = shift @$row;
    $analyze{metric_order} = shift @$row;
    $analyze{metric_name} = shift @$row;
    $analyze{metric_field} = &from_db_null_to_undef(shift @$row);
    $analyze{baseline_id} = shift @$row;
    $analyze{baseline_val} = shift @$row;
    $analyze{new_id} = shift @$row;
    $analyze{new_val} = shift @$row;
    $analyze{improvement} = shift @$row;

    die "elems remaining" if(@$row);

    return \%analyze;
}

sub to_db_analyze_stuff
{
    my $analyze = shift;
    my ($trace_input_id, $metric_order, $metric_name, $metric_field,
	$baseline_id, $baseline_val, $new_id, $new_val, $improvement);

    die "metric_order too big"
	if(length($analyze->{metric_order}) > $ana_metric_order_len);
    die "metric_name too big"
	if(length($analyze->{metric_name}) > $dist_kind_len);
    if(defined($analyze->{metric_field})) {
	die "metric_field too big"
	    if(length($analyze->{metric_field}) > $dist_kind_len);
    }

    $trace_input_id = $analyze->{trace_input_id};
    $metric_order = $dbh->quote($analyze->{metric_order});
    $metric_name = $dbh->quote($analyze->{metric_name});
    $metric_field = &to_db_undef_to_null($analyze->{metric_field});
    $baseline_id = $analyze->{baseline_id};
    $baseline_val = $analyze->{baseline_val};
    $new_id = $analyze->{new_id};
    $new_val = $analyze->{new_val};
    $improvement = $analyze->{improvement};

    return ($trace_input_id, $metric_order, $metric_name, $metric_field,
	    $baseline_id, $baseline_val, $new_id, $new_val, $improvement);
}

sub db_find_analyze_id
{
    my ($trace_input_id_in, $metric_order_in, $metric_name_in,
	$metric_field_in, $baseline_id_in, $new_id_in) = @_;
    my ($trace_input_id, $metric_order, $metric_name, $metric_field,
	$baseline_id, $new_id);
    my $analyze_id;
    my ($where_str, $select_str);
    my ($sth, @row, $ret);

    $trace_input_id = $trace_input_id_in;
    $metric_order = $dbh->quote($metric_order_in);
    $metric_name = $dbh->quote($metric_name_in);
    $metric_field = $dbh->quote($metric_field_in);
    $baseline_id = $baseline_id_in;
    $new_id = $new_id_in;

    $where_str = join(" AND ", "a.trace_input_id = $trace_input_id",
		      "a.metric_order = $metric_order",
		      "a.metric_name = $metric_name",
		      "a.metric_field <=> $metric_field",
		      "a.baseline_id = $baseline_id",
		      "a.new_id = $new_id");
    $select_str = "SELECT id FROM analysis a WHERE $where_str";
    $sth = $dbh->prepare($select_str);
    $ret = $sth->execute;
    die "incorrect number of rows" if($ret > 1 || $ret < 0);
    @row = $sth->fetchrow_array;
    if(!@row) {
	return undef;
    }
    $analyze_id = $row[0];
    die "too many rows" if(defined($sth->fetchrow_array));

    return $analyze_id;
}

######################################################################

# cols helpers

sub make_cols_vars
{
    my $shared_cols_types;

    $shared_cols_types = &make_shared_cols_types;

    $complete_trace_cols_types =
	join(',', $shared_cols_types, &make_trace_cols_types);
    $complete_output_cols_types =
	join(',', $shared_cols_types, &make_output_cols_types);
    $complete_analyze_cols_types = &make_analyze_cols_types;

    $complete_trace_cols =
	&make_str_of_first_words($complete_trace_cols_types);
    $complete_output_cols =
	&make_str_of_first_words($complete_output_cols_types);
    $complete_analyze_cols =
	&make_str_of_first_words($complete_analyze_cols_types);

    $made_cols_vars = true;
}

sub make_shared_cols_types
{
    my $str;

    $str = join(',',  $id_col, $program_col, $version_col, $hostname_col,
		$args_col, $run_date_col, $random_seed_col, $trace_input_col,
		$trace_output_col);

    return $str;
}

sub make_trace_cols_types
{
    return join(',', $num_users_col, $virtual_clock_terminate_col,
		$max_req_dis_tasks_per_user_col,
		&dist_col_str($user_arrivals_col),
		&dist_col_str($task_set_change_range_col),
		&dist_col_str($tasks_per_task_set_col),
		&dist_col_str($service_time_col),
		&dist_col_str($think_time_col));
}

sub make_output_cols_types
{
    return join(',', $trace_input_id_col,
		$treat_req_dis_diff_col,
		$req_sched_col, $dis_sched_col,
		$virtual_clock_col,
		$all_cand_queue_col, $all_cand_queue_weighed_col,
		$req_cand_queue_col, $req_cand_queue_weighed_col,
		$dis_cand_queue_col, $dis_cand_queue_weighed_col,
		&stats_col_str($all_res_usage_col),
		&stats_col_str($req_res_usage_col),
		&stats_col_str($dis_res_usage_col),
		&stats_col_str($scaled_res_usage_col),
		&stats_col_str($billable_resources_col),
		$res_busy_range_time_col, $res_busy_time_col,
		$res_idle_time_col, $non_work_cons_time_col, $load_col,
		$req_load_col, $req_load_ignoring_idle_col,
		$user_count_col, $num_hit_req_dis_limit_col,
		&stats_col_str($task_sets_col), $task_sets_alive_time_col,
		$no_task_sets_alive_time_col, $tasks_ready_time_col,
		&stats_col_str($disclosed_tasks_col),
		&stats_col_str($disclosed_only_tasks_col),
		&stats_col_str($executed_tasks_col),
		&stats_col_str($requested_tasks_col),
		&stats_col_str($finished_tasks_col),
		&stats_col_str($canceled_tasks_col),
		&stats_col_str($vrt_col),
		&stats_col_str($vsd_col),
		&stats_col_str($user_vrt_col),
		&stats_col_str($user_vsd_col),
		&stats_col_str($deadlines_met_col));
}

sub make_analyze_cols_types
{
    return join(',', $ana_id_col, $ana_trace_input_id_col,
		$ana_metric_order_col, $ana_metric_name_col,
		$ana_metric_field_col, $ana_baseline_id_col,
		$ana_baseline_val_col, $ana_new_id_col, $ana_new_val_col,
		$ana_improvement_col);
}

sub make_str_of_first_words
{
    my $orig_str = shift;
    my @orig_list;
    my @new_list;
    my $new_str;

# get rid of things inside parens, because commas can hide there (ex:
# DECIMAL(10,3)) and screw up the following join.
    $orig_str =~ s/\([^)]+\)/\(\)/g;

    @orig_list = split /,/, $orig_str;
    foreach my $words (@orig_list) {
	my $first;

	if($words =~ /^(\w+)/) {
	    $first = $1;
	} else {
	    die;
	}

	push @new_list, $first;
    }

    return join ',', @new_list;
}

sub get_complete_trace_cols
{
    if($made_cols_vars == false) {
	&make_cols_vars;
    }

    return $complete_trace_cols;
}

sub get_complete_trace_cols_types
{
    if($made_cols_vars == false) {
	&make_cols_vars;
    }

    return $complete_trace_cols_types;
}

sub get_complete_output_cols
{
    if($made_cols_vars == false) {
	&make_cols_vars;
    }

    return $complete_output_cols;
}

sub get_complete_output_cols_types
{
    if($made_cols_vars == false) {
	&make_cols_vars;
    }

    return $complete_output_cols_types;
}

sub get_complete_analyze_cols
{
    if($made_cols_vars == false) {
	&make_cols_vars;
    }

    return $complete_analyze_cols;
}

sub get_complete_analyze_cols_types
{
    if($made_cols_vars == false) {
	&make_cols_vars;
    }

    return $complete_analyze_cols_types;
}

sub make_key_str
{
    my $key = shift;

    return "KEY $key ($key)";
}

sub make_dist_key_str
{
    my $key = shift;
    my $dist_keys_str;

    $dist_keys_str = "INDEX $key (" .
	join(",",
	     "${key}_kind",
	     "${key}_alpha",
	     "${key}_beta",
	     "${key}_mean",
	     "${key}_prob") .
	     ")";

    return $dist_keys_str;
}

######################################################################

# stats helpers

sub stats_col_str
{
    my $name = shift;
    my $str;

    $str = "";
    $str .= "${name}_mean $real_fmt NOT NULL,";
    $str .= "${name}_total $real_fmt NOT NULL,";
    $str .= "${name}_min $real_fmt NOT NULL,";
    $str .= "${name}_max $real_fmt NOT NULL,";
    $str .= "${name}_stddev $real_fmt NOT NULL,";
    $str .= "${name}_count $real_fmt NOT NULL";

    return $str;
}

sub list_to_stats
{
    my $row = shift;
    my @stats;
    my $elem;

    $elem = shift @$row; # mean
    push @stats, $elem;
    $elem = shift @$row; # total
    push @stats, $elem;
    $elem = shift @$row; # min
    push @stats, $elem;
    $elem = shift @$row; # max
    push @stats, $elem;
    $elem = shift @$row; # stddev
    push @stats, $elem;
    $elem = shift @$row; # count
    push @stats, $elem;

    return \@stats;
}

######################################################################

# dist helpers

sub dist_col_str
{
    my $name = shift;
    my $str;

    $str = "";
    $str .= "${name}_kind VARCHAR($dist_kind_len) BINARY NOT NULL,";
    $str .= "${name}_alpha $dist_real_fmt NULL,";
    $str .= "${name}_beta $dist_real_fmt NULL,";
    $str .= "${name}_mean $dist_real_fmt NULL,";
    $str .= "${name}_prob $dist_real_fmt NULL";

    return $str;
}

sub dist_str_from_args
{
    my ($kind, $alpha, $beta, $mean, $prob) = @_;
    my $dist_str;

    $dist_str = "$kind:";

    if($kind eq "uniform") {
	$dist_str .= "$alpha,$beta";
    } elsif($kind eq "exponential") {
	$dist_str .= "$mean";
    } elsif($kind eq "pareto") {
	$dist_str .= "$alpha,$beta,$mean";
    } elsif($kind eq "bernoulli") {
	$dist_str .= "$prob";
    } elsif($kind eq "poisson") {
	$dist_str .= "$mean";
    } else {
	die "unknown dist kind";
    }

    return $dist_str;
}

sub to_db_dist
{
    my $dist = shift;
    my $db_str;
    my @db_vals;

    @db_vals = &to_db_dist_helper($dist);

    $db_vals[0] = $dbh->quote($db_vals[0]); # kind

    $db_str = join ",", @db_vals;

    return $db_str;
}

sub to_db_dist_comp
{
    my $dist = shift;
    my $name = shift;
    my @db_vals;
    my @db_comp_vals;
    my $db_comp_str;
    my ($kind, $alpha, $beta, $mean, $prob);

    @db_vals = &to_db_dist_helper($dist);

    $kind = shift @db_vals;
    push @db_comp_vals, "t.${name}_kind = " . $dbh->quote($kind);

    if($kind eq "uniform") {
	$alpha = shift @db_vals;
	$beta = shift @db_vals;
	shift @db_vals;
	shift @db_vals;
	push @db_comp_vals, "t.${name}_alpha = $alpha";
	push @db_comp_vals, "t.${name}_beta = $beta";
    } elsif($kind eq "exponential") {
	shift @db_vals;
	shift @db_vals;
	$mean = shift @db_vals;
	shift @db_vals;
	push @db_comp_vals, "t.${name}_mean = $mean";
    } elsif($kind eq "pareto") {
	$alpha = shift @db_vals;
	$beta = shift @db_vals;
	$mean = shift @db_vals;
	shift @db_vals;
	push @db_comp_vals, "t.${name}_alpha = $alpha";
	push @db_comp_vals, "t.${name}_beta = $beta";
	push @db_comp_vals, "t.${name}_mean = $mean";
    } elsif($kind eq "bernoulli") {
	shift @db_vals;
	shift @db_vals;
	shift @db_vals;
	$prob = shift @db_vals;
	push @db_comp_vals, "t.${name}_prob = $prob";
    } elsif($kind eq "poisson") {
	shift @db_vals;
	shift @db_vals;
	$mean = shift @db_vals;
	shift @db_vals;
	push @db_comp_vals, "t.${name}_mean = $mean";
    } else {
	die "unknown kind: `$kind'";
    }

    die "db_vals (dist) should be over" if(@db_vals);

    $db_comp_str = join " AND ", @db_comp_vals;

    return $db_comp_str;
}

sub to_db_dist_helper
{
    my $dist = shift;
    my @db_vals;
    my $kind;

    @db_vals = &dist_to_list($dist);

    $kind = $db_vals[0];
    die "dist kind `$kind' too big" if(length($kind) > $dist_kind_len);

    return @db_vals;
}

######################################################################
