#ifndef __BA_REPORT_H__
#define __BA_REPORT_H__

#include <ba_config.h>

// scheduler
extern void ba_report_events_virtual_clock_start_end(ba_real start_abs_time,
						     ba_real end_abs_time);
extern void ba_report_sched_candidates(uint32_t num_all_candidates,
				       uint32_t num_req_candidates,
				       uint32_t num_dis_candidates,
				       ba_real abs_time);
extern void ba_report_sched_weighed_candidates(uint32_t weighed_all_candidates,
					       uint32_t weighed_req_candidates,
					       uint32_t weighed_dis_candidates,
					       ba_real abs_time);

// resources
extern void ba_report_user_resource_usage(ba_real resource_usage);
extern void ba_report_user_req_resource_usage(ba_real req_resource_usage);
extern void ba_report_user_dis_resource_usage(ba_real dis_resource_usage);
extern void ba_report_user_scaled_resource_usage(ba_real
						      scaled_resource_usage);
extern void ba_report_resource_busy_start_end(ba_real start_abs_time,
					      ba_real end_abs_time);

// tasks and task sets
extern void ba_report_users_inc_user_count(void);
extern void ba_report_user_inc_num_hit_req_dis_limit(void);
extern void ba_report_user_task_sets(uint32_t task_sets);
extern void ba_report_task_set_alive_start_end(ba_real start_abs_time,
					       ba_real end_abs_time);
extern void ba_report_task_set_ready_tasks_start_end(ba_real start_abs_time,
						     ba_real end_abs_time);
extern void ba_report_user_disclosed_tasks(uint32_t num_tasks);
extern void ba_report_user_disclosed_only_tasks(uint32_t num_tasks);
extern void ba_report_user_executed_tasks(uint32_t num_tasks);
extern void ba_report_user_requested_tasks(uint32_t num_tasks);
extern void ba_report_user_finished_tasks(uint32_t num_tasks);
extern void ba_report_user_canceled_tasks(uint32_t num_tasks);
extern void ba_report_user_service_delta_time(ba_real service_delta_time);
extern void ba_report_user_think_delta_time(ba_real think_delta_time);

// visible response time
extern void ba_report_user_vrt_delta_time(ba_real vrt_delta_time);
extern void ba_report_user_vsd(ba_real vsd);
extern void ba_report_user_user_vrt_delta_time(ba_real
							 vrt_delta_time);
extern void ba_report_user_user_vsd(ba_real vsd);
extern void ba_report_user_deadlines_met(uint32_t deadlines_met);

// other
extern void ba_report_print_proem_to(ba_print_func_t *print_func);
extern void ba_report_print_user_behavior_to(ba_print_func_t *print_func);

extern void ba_report_output(void);
extern ba_bool ba_report_warmup_met(void);
extern ba_real ba_report_warmup_abs_time_get(void);

extern ba_status ba_report_init(void);
extern ba_status ba_report_destroy(void);
extern void ba_report_destroy_from_hook(void *unused);

#endif /* !__BA_REPORT_H__ */
