#ifndef __BA_RV_H__
#define __BA_RV_H__

#include <ba_config.h>

typedef struct ba_rv_dist_s ba_rv_dist_t;

extern char *ba_rv_dist_name_get(ba_rv_dist_t *dist);
extern void ba_rv_distributions_print(void);
extern ba_bool ba_rv_dist_values_used_get(char *name,
					  ba_bool *alpha_used,
					  ba_bool *beta_used,
					  ba_bool *mean_used,
					  ba_bool *prob_used);
extern void ba_rv_setup_random_generator(void);
extern ba_real ba_rv_dist(ba_rv_dist_t *dist);
extern void ba_rv_dist_print(ba_rv_dist_t *dist);
extern void ba_rv_dist_print_nice(ba_rv_dist_t *dist);
extern void ba_rv_dist_print_short_to(ba_rv_dist_t *dist,
				      ba_print_func_t *print_func);
extern void ba_rv_dist_print_short(ba_rv_dist_t *dist);
extern ba_rv_dist_t *ba_rv_dist_copy(ba_rv_dist_t *dist_src);
extern ba_rv_dist_t *ba_rv_dist_new(char *name,
				    ba_real alpha,
				    ba_real beta,
				    ba_real mean,
				    ba_real prob);
extern void ba_rv_dist_delete(ba_rv_dist_t *dist);

extern ba_status ba_rv_init(void);
extern ba_status ba_rv_destroy(void);
extern void ba_rv_destroy_from_hook(void *unused);

#endif /* !__BA_RV_H__ */
