#!/usr/bin/perl -w

die "Change this script to use a version of Perl greater than or equal to 5."
    if $PERL_VERSION < 5;

use strict;
use English;

use ba_stat_nums;

use constant false => 0;
use constant true => 1;

my $stat;
my (@sched_desc_counts, @sched_desc_totals,
   @scaled_sched_desc_counts, @scaled_sched_desc_totals,
   @all_finished_tasks);

foreach my $arg (@ARGV) {
    my @lines;
    my ($found_sched_desc_count, $found_sched_desc_total,
	$found_finished_tasks);
    my ($sched_desc_count, $sched_desc_total, $finished_tasks);

    @lines = `cat $arg`;

    $found_sched_desc_count = $found_sched_desc_total = $found_finished_tasks =
	false;

    foreach my $line (@lines) {
	if($line =~ /^  count: (.+)$/) {
	    $found_sched_desc_count = true;
	    $sched_desc_count = $1;
	    last;
	}
    }
    die if($found_sched_desc_count == false);

    foreach my $line (@lines) {
	if($line =~ /^  total: (.+)$/) {
	    $found_sched_desc_total = true;
	    $sched_desc_total = $1;
	    last;
	}
    }
    die if($found_sched_desc_total == false);

    foreach my $line (@lines) {
	if($line =~ /^finished tasks: ([^,]+), ([^,]+)/) {
	    $found_finished_tasks = true;
	    $finished_tasks = $2;
	    last;
	}
    }
    die if($found_finished_tasks == false);

    push @sched_desc_counts, $sched_desc_count;
    push @sched_desc_totals, $sched_desc_total;
    push @scaled_sched_desc_counts, $sched_desc_count / $finished_tasks;
    push @scaled_sched_desc_totals, $sched_desc_total / $finished_tasks;
    push @all_finished_tasks, $finished_tasks;
}

print "sched_desc_counts:\n";
&stat_nums_print(\@sched_desc_counts);
print "\n";

print "sched_desc_totals:\n";
&stat_nums_print(\@sched_desc_totals);
print "\n";

print "scaled_sched_desc_counts:\n";
&stat_nums_print(\@scaled_sched_desc_counts);
print "\n";

print "scaled_sched_desc_totals:\n";
&stat_nums_print(\@scaled_sched_desc_totals);
print "\n";

print "all_finished_tasks:\n";
&stat_nums_print(\@all_finished_tasks);
