#ifndef __BA_STATS_H__
#define __BA_STATS_H__

#include <ba_config.h>

typedef struct ba_stats_s ba_stats_t;
typedef struct ba_stats_running_mean_s ba_stats_running_mean_t;

extern ba_bool ba_stats_equal(ba_stats_t *stats1,
			      ba_stats_t *stats2);
extern ba_bool ba_stats_non_empty(ba_stats_t *stats);
extern ba_real ba_stats_count_get(ba_stats_t *stats);
extern ba_real ba_stats_total_get(ba_stats_t *stats);
extern ba_real ba_stats_min_get(ba_stats_t *stats);
extern ba_real ba_stats_max_get(ba_stats_t *stats);
extern ba_real ba_stats_sample_mean_get(ba_stats_t *stats);
extern ba_real ba_stats_sample_variance_get(ba_stats_t *stats);
extern ba_real ba_stats_standard_deviation_get(ba_stats_t *stats);
extern void ba_stats_insert(ba_stats_t *stats,
			    ba_real value);
extern void ba_stats_print(ba_stats_t *stats);
extern void ba_stats_print_nice_to(ba_stats_t *stats,
				   ba_print_func_t *print_func);
extern void ba_stats_print_nice_maybe_none_to(ba_stats_t *stats,
					      ba_print_func_t *print_func);
extern void ba_stats_print_nice(ba_stats_t *stats);

extern ba_stats_t *ba_stats_new(void);
extern void ba_stats_delete(ba_stats_t *stats);
extern void ba_stats_delete_from_list(void *stats_in,
				      void *unused);

extern void ba_stats_running_mean_print(ba_stats_running_mean_t *rm_stats);
extern ba_real ba_stats_running_mean_get(ba_stats_running_mean_t *rm_stats);
extern void ba_stats_running_mean_insert(ba_stats_running_mean_t *rm_stats,
					 ba_real value,
					 ba_real abs_time);
extern ba_stats_running_mean_t *ba_stats_running_mean_new(void);
extern void ba_stats_running_mean_delete(ba_stats_running_mean_t *rm_stats);
extern void ba_stats_running_mean_delete_from_list(void *rm_stats_in,
						   void *unused);

#endif /* !__BA_STATS_H__ */
