#ifndef __BA_TASK_SET_H__
#define __BA_TASK_SET_H__

#include <ba_config.h>

typedef struct ba_task_set_s ba_task_set_t;

extern ba_task_t *ba_task_set_return_unexecuted_task(ba_task_set_t
						     *task_set);
extern ba_task_t *ba_task_set_return_next_unrequested_task(ba_task_set_t
							   *task_set);
extern void ba_task_set_report(ba_task_set_t *task_set);
extern void ba_task_set_activated_abs_time_set(ba_task_set_t *task_set,
					       ba_real activated_abs_time);
extern ba_real ba_task_set_activated_abs_time_get(ba_task_set_t *task_set);
extern void ba_task_set_deactivated_abs_time_set(ba_task_set_t *task_set,
						 ba_real deactivated_abs_time);
extern void ba_task_set_last_task_executed_abs_time_set(ba_task_set_t
							*task_set,
						ba_real last_task_abs_time);
extern ba_real ba_task_set_last_task_executed_abs_time_get(ba_task_set_t
							   *task_set);
extern ba_id_t ba_task_set_id_get(ba_task_set_t *task_set);
extern ba_user_t *ba_task_set_user_get(ba_task_set_t *task_set);
extern void ba_task_set_disclose_all(ba_task_set_t *task_set);
extern void ba_task_set_append_task(ba_task_set_t *task_set,
				    ba_task_t *task);
extern ba_bool ba_task_set_is_empty(ba_task_set_t *task_set);
extern void ba_task_set_print(ba_task_set_t *task_set);
extern void ba_task_set_print_from_list(void *task_set_in,
					void *unused);

extern ba_task_set_t *ba_task_set_new(ba_id_t id,
				      ba_user_t *user);
extern void ba_task_set_delete(ba_task_set_t *task_set);
extern void ba_task_set_delete_from_list(void *task_set_in,
					 void *unused);

#endif /* !__BA_TASK_SET_H__ */
