#ifndef __BA_TRACE_H__
#define __BA_TRACE_H__

#include <ba_config.h>

typedef enum {
    BA_TRACE_ENTRY_NEW_USER = 0,
    BA_TRACE_ENTRY_TASK_SET_CHANGE_PROB,
    BA_TRACE_ENTRY_TASKS_PER_TASK_SET,
    BA_TRACE_ENTRY_TASK_SET_CHANGE,
    BA_TRACE_ENTRY_SERVICE_DELTA_TIME,
    BA_TRACE_ENTRY_THINK_DELTA_TIME,
    BA_TRACE_ENTRY_UNKNOWN,
} ba_trace_entry_t;

typedef ba_real (ba_trace_gen_rv_t)(void *generic_data);

extern ba_bool ba_trace_read_trace_input_get(void);
extern ba_bool ba_trace_write_trace_output_get(void);
extern uint32_t ba_trace_num_users_get(void);
extern uint32_t ba_trace_max_req_dis_tasks_per_user_get(void);

extern ba_real ba_trace_get_and_log_rv(ba_trace_entry_t type,
				       ba_id_t user_id,
				       ba_id_t task_id,
				       ba_trace_gen_rv_t gen_rv_func,
				       void *gen_rv_data);
extern ba_status ba_trace_init(void);
extern ba_status ba_trace_destroy(void);
extern void ba_trace_destroy_from_hook(void *unused);

#endif /* !__BA_TRACE_H__ */
